#define F_CPU 12000000L
#include <util/delay.h>
#include <avr/io.h>
#include <math.h>

//Value for Check State
int start = 0;
int start1 = 0;
int start2 = 0;

void showtime(float float_time)
{
	int time = (int)(float_time);
//7-Segment Port D
	if(time % 10 == 0)
	{
		PORTD = 0b00000000;
	}
	if(time % 10 == 1)
	{
		PORTD = 0b00000001;
	}
	if(time % 10 == 2)
	{
		PORTD = 0b00000010;
	}
	if(time % 10 == 3)
	{
		PORTD = 0b00000011;
	}
	if(time % 10 == 4)
	{
		PORTD = 0b00100000;
	}
	if(time % 10 == 5)
	{
		PORTD = 0b00100001;
	}
	if(time % 10 == 6)
	{
		PORTD = 0b00100010;
	}
	if(time % 10 == 7)
	{
		PORTD = 0b00100011;
	}
	if(time % 10 == 8)
	{
		PORTD = 0b01000000;
	}
	if(time % 10 == 9)
	{
		PORTD = 0b01000001;
	}
//7-Segment Port B
	if(time / 10 == 0)
	{
		PORTB = 0b00000000;
	}
	if(time / 10 == 1)
	{
		PORTB = 0b00000100;
	}
	if(time / 10 == 2)
	{
		PORTB = 0b00001000;
	}
	if(time / 10 == 3)
	{
		PORTB = 0b00001100;
	}
	if(time / 10 == 4)
	{
		PORTB = 0b00010000;
	}
	if(time / 10 == 5)
	{
		PORTB = 0b00010100;
	}
	if(time / 10 == 6)
	{
		PORTB = 0b00011000;
	}
	if(time / 10 == 7)
	{
		PORTB = 0b00011100;
	}
	if(time / 10 == 8)
	{
		PORTB = 0b00100000;
	}
	if(time / 10 == 9)
	{
		PORTB = 0b00100100;
	}
	return ;
}

void check_win(float p1_time,float p2_time,float time)
{
	start = 1;
	if(fabs(p1_time-time)<fabs(p2_time-time))
    	{
        	while((PINC &  0b00000011) != 0b00000000)
		{ 
			PORTB |= 0b00000001;
			showtime(p1_time);	
		}
        
    	}
    	else if(fabs(p1_time-time)>fabs(p2_time-time))
    	{
		while((PINC &  0b00000011) != 0b00000000)
		{     	   	
			PORTB |= 0b00000010;
			showtime(p2_time);
		}
    	}
       	return ;
}

main()
{
    	DDRB  = 0b00111111; // Output (0,1 for LED | 2-5 for 7-segment)
	PORTB = 0b00000000; 
    	DDRC  = 0b00110000; // Output (4,5 for LED) , Input (0-3 for Switch)
	PORTC = 0b00001111;
    	DDRD  = 0b01111111; // Output (0,1,5,6 for 7-segment)
	PORTD = 0b00001000; 		
    	float time = 0.00;
    	float p1_time = 0.00,p2_time = 0.00;
    	int p1_ctrl =0,p2_ctrl = 0; 

    while (1)
    {

	if ((PINC & 0b00001111) == 0b00001111)  // No input
	{
		if(p1_ctrl==1 && p2_ctrl == 1)
            	{
			showtime(p1_time);
			_delay_ms(1000);
			showtime(p2_time);
			_delay_ms(1000);
                	check_win(p1_time,p2_time,time);
			p1_ctrl = 0;
			p2_ctrl = 0;
            	}
		if(p1_ctrl==1 && p2_ctrl == 0)
            	{
                	showtime(p1_time);	
            	}
		if(p1_ctrl==0 && p2_ctrl == 1)
            	{
                	showtime(p2_time);	
            	}
	}
	else if(((PINC & 0b00001111) == 0b00001110) & start == 0 & start1 == 0 & start2 == 0)  // input time = 15 sec
	{
		PORTB = 0b00000100;  // show 15 on 7-segment 
		PORTD = 0b00100001;
		time = 15.00;
	}
        else if(((PINC & 0b00001111)  == 0b00001101) & start == 0 & start1 == 0 & start2 == 0)  // input time = 30 sec
	{
		PORTB = 0b00001100;  // show 30 on 7-segment
		PORTD = 0b00000000; 
		time = 30.00;
	}
        else if(((PINC & 0b00001111) == 0b00001011) & time != 0 & start == 0 & start1 == 0)  // P1_start
	{		
		PORTC |= 0b00010000;  // LED P1 on
            	p1_ctrl = 1;
		_delay_ms(10);
            	p1_time += 0.01;
		//showtime(p1_time); // Test time
		if((PINC & 0b00001111) != 0b00001011)
		{
			start1 = 1;	
		}
	}
        else if(((PINC & 0b00001111) == 0b00000111) & time != 0 & start == 0 & start2 == 0)  // P2_start
	{
		PORTC |= 0b00100111;  // LED P2 on
            	p2_ctrl = 1;
            	_delay_ms(10);
            	p2_time += 0.01;
		//showtime(p2_time); // Test time
		if((PINC & 0b00001111) != 0b00000111)
		{
			start2 = 1;
		}
	}
	
        else if((PINC &  0b00000011) == 0b00000000)  // reset
	{
		PORTB = 0b00000000;	 
		PORTC = 0b00001111;
		PORTD = 0b00001000;
    		time = 0.00;
    		start = 0; 
		start1 = 0; 
		start2 = 0;
    		p1_time = 0.00;
		p2_time = 0.00;
    		p1_ctrl= 0,p2_ctrl = 0; 
		_delay_ms(500);
	}
    }
}

